package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class MovimentacaoDeEstoquePage extends PageBase {

    //Evento de loading da pagina:
    By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");
    //BUSCA DO PRODUTO ATRAVES DO FLOAT-CONTROL:

    By campoProcurarFloatControl = By.xpath("//*[@id='popup']//*[@placeholder='Procurar']");
    By IconSearch = By.xpath("//*[@data-zh-id='filter-floating-card']//*[@zh-icon='search no-border icon-white']");



    //RELATORIO:
    By tabIndexRelatorio = By.xpath("//*[@data-zh-id='195204867136516877052928']//*[@tabindex = '0']");
    By MovimentacaoDeEstoqueAnalitico = By.xpath("//*[@data-zh-id='195204867136516877052928']//*[@data-value= '0']");




    //UNIDADE:
    By btnXlimpar = By.xpath("//*[@data-zh-id='19520486718467158722930']//*[@zh-icon='no-border close-x']");
    By IconeUnidade = By.xpath("//*[@data-zh-id='19520486718467158722930']//*[@id='NMFILIAL']/span[1]");
    By SelecionarUnidadeMovimentacaoEstoque = By.xpath("//*[@data-zh-field-name='NMFILIAL']//*[.='HELA INGREDIENTES BRASIL']");



     //ALMOXARIFADO:
    By IconSearchAlmoxarife = By.xpath("//*[@data-zh-id='195204867141917611572934']//*[@id='DSALMOXARIFE']/span");
    By almoxarifado = By.xpath("//*[@id='grid-9000']//*[.='HELA MATRIZ']");//Nao precisa de data-zh-id



    //LOTE:
    By btnIconLote = By.xpath("//*[@data-zh-id='195204867125718357092941']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By lote = By.xpath("//*[@id='grid-9000']//*[.='00154/2023']");//Nao precisa de data-zh-id



    //PERIODO:
    By btnXlimparDataPeriodo = By.xpath("//*[@data-zh-id='19520486712477760065965']//*[@zh-icon='no-border close-x']");
    By IconCalendario = By.xpath("//*[@data-zh-id='19520486712477760065965']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
    By DataEscolhida = By.xpath("//*[@id='zh-calendar-Calendar']//*[.='1']");//Nao precisa de data-zh-id
    By BtnOkFiltro = By.xpath("//*[@id='footer']/div[3]/ul/li/a/span");



    //PRODUTO INICIAL:
    By IconSearchProdutoInicial = By.xpath("//*[@data-zh-id='195204867111229283542950']//*[@id='NMPRODINI']/span[1]");
    By produto = By.xpath("//*[@id='grid-9000']//*[.='Hela Poultry Broth Paste Clear KG']");//Nao precisa de data-zh-id
    //PRODUTO FINAL:
    By IconSearchProdutoFinal = By.xpath("//*[@data-zh-id='195204867132117945872953']//*[@id='NMPRODFIN']/span[1]");
    By produtoFinal = By.xpath("//*[@id='grid-9000']//*[.='Hela Poultry Broth Paste Clear KG']");//Nao precisa de data-zh-id



    //NIVEL P/TOTALIZAÇÃO:
    By tabIndexNivelTotalizacao = By.xpath("//*[@data-zh-id='19520486718549359272958']//*[@tabindex = '0']");
    By NivelTotalizacao = By.xpath("//*[@data-zh-id='19520486718549359272958']//*[@data-value= '0']");



    //EM GRID:
    By btnGerarPDF= By.xpath("//*[@data-zh-id='19520486713171166342179']");

    By gridRelatorioPosicao = By.xpath("https://automacao-erp.teknisa.com//est/#/est_relatorios#est31100_grid_relatorio_posicao");



    public void indexRelatorio(){
        waitForVisibilityOfElementLocated(tabIndexRelatorio);
        click(tabIndexRelatorio);
    };
    public void estoqueAnalitico(){
        waitForVisibilityOfElementLocated(MovimentacaoDeEstoqueAnalitico);
        click(MovimentacaoDeEstoqueAnalitico);
        waitForInvisibilityOfElementLocated(loadingWait);
    };

    public void limpar(){
        waitForVisibilityOfElementLocated(btnXlimpar);
        click(btnXlimpar);
    };
    public void campoUnidade(){
        waitForVisibilityOfElementLocated(IconeUnidade);
        click(IconeUnidade);
    };
    public void buttonPesquisarUnidade(){
        waitForVisibilityOfElementLocated(IconSearch);
        click(IconSearch);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void buscarUnidade(String descUnidade){
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void selecionarMovimentacaoDeEstoque(){
        waitForVisibilityOfElementLocated(SelecionarUnidadeMovimentacaoEstoque);
        click(SelecionarUnidadeMovimentacaoEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void campoAlmoxarifado(){
        waitForVisibilityOfElementLocated(IconSearchAlmoxarife);
        click(IconSearchAlmoxarife);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void buscarAlmoxarifado(String descAlmoxarifado){
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        waitForInvisibilityOfElementLocated(loadingWait);
        sendKeys(campoProcurarFloatControl,descAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void selecionarAlmoxarifado(){
        waitForVisibilityOfElementLocated(almoxarifado);
        click(almoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void campoLote(){
        waitForVisibilityOfElementLocated(btnIconLote);
        click(btnIconLote);
        waitForInvisibilityOfElementLocated(loadingWait);
    };

    public void buscaLote(String descLote){
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descLote);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void selecionarLote(){
        waitForVisibilityOfElementLocated(lote);
        click(lote);
    };

    public void limparData(){
        waitForVisibilityOfElementLocated(btnXlimparDataPeriodo);
        click(btnXlimparDataPeriodo);
    };

    public void selecionarCalendario(){
        waitForVisibilityOfElementLocated(IconCalendario);
        click(IconCalendario);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void dataEscolhida(){
        waitForVisibilityOfElementLocated(DataEscolhida);
        click(DataEscolhida);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void limparFiltro(){
        waitForVisibilityOfElementLocated(BtnOkFiltro);
        click(BtnOkFiltro); //data-zh-id esta vazio
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void campoProdutoInicial(){
        waitForVisibilityOfElementLocated(IconSearchProdutoInicial);
        click(IconSearchProdutoInicial);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void buscarProdutoInicial(String descProduto){
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void selecionarProdutoInicial(){
        waitForVisibilityOfElementLocated(produto);
        click(produto);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void campoProdutoFinal(){
        waitForVisibilityOfElementLocated(IconSearchProdutoFinal);
        click(IconSearchProdutoFinal);
        waitForInvisibilityOfElementLocated(loadingWait);
    };

    public void buscarProdutoFinal(String descProduto){
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
    };

    public void selecionarProdutoFinal(){
        waitForVisibilityOfElementLocated(produtoFinal);
        click(produtoFinal);
        waitForInvisibilityOfElementLocated(loadingWait);
    };

    public void indexNivelDeTotalizacao(){
        waitForVisibilityOfElementLocated(tabIndexNivelTotalizacao);
        click(tabIndexNivelTotalizacao);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void nivelDeTotalizacao(){
        waitForVisibilityOfElementLocated(NivelTotalizacao);
        click(NivelTotalizacao);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void buttonGerarPDF(){
        waitForVisibilityOfElementLocated(btnGerarPDF);
        click(btnGerarPDF);
        waitForInvisibilityOfElementLocated(loadingWait);
    };

}
